## Array functions

### `at`

**Description:** Performs the `at` operation.

```js
at(...) // => ...
```

### `chunk`

**Description:** Performs the `chunk` operation.

```js
chunk(...) // => ...
```

### `concat`

**Description:** Concatenates two arrays.

```js
concat(...) // => ...
```

### `cons`

**Description:** Performs the `cons` operation.

```js
cons(...) // => ...
```

### `count`

**Description:** Performs the `count` operation.

```js
count(...) // => ...
```

### `difference`

**Description:** Performs the `difference` operation.

```js
difference(...) // => ...
```

### `every`

**Description:** Performs the `every` operation.

```js
every(...) // => ...
```

### `filter`

**Description:** Applies `filter` operation to a list.

```js
filter(x => x > 1)([1, 2, 3]) // => [2, 3]
```

### `find`

**Description:** Performs the `find` operation.

```js
find(...) // => ...
```

### `findAllIndexes`

**Description:** Performs the `findAllIndexes` operation.

```js
findAllIndexes(...) // => ...
```

### `findIndex`

**Description:** Performs the `findIndex` operation.

```js
findIndex(...) // => ...
```

### `findLastIndex`

**Description:** Performs the `findLastIndex` operation.

```js
findLastIndex(...) // => ...
```

### `first`

**Description:** Performs the `first` operation.

```js
first(...) // => ...
```

### `flat`

**Description:** Performs the `flat` operation.

```js
flat(...) // => ...
```

### `flatMap`

**Description:** Performs the `flatMap` operation.

```js
flatMap(...) // => ...
```

### `flatten`

**Description:** Flattens a nested array one level.

```js
flatten([1, [2, 3]]) // => [1, 2, 3]
```

### `flattenAll`

**Description:** Recursively flattens a deeply nested array.

```js
flattenAll([1, [2, [3, [4]]]]) // => [1, 2, 3, 4]
```

### `fold`

**Description:** Applies `fold` operation to a list.

```js
fold(...) // => ...
```

### `forEach`

**Description:** Performs the `forEach` operation.

```js
forEach(...) // => ...
```

### `getArrayKeys`

**Description:** Performs the `getArrayKeys` operation.

```js
getArrayKeys(...) // => ...
```

### `hasAllElems`

**Description:** Performs the `hasAllElems` operation.

```js
hasAllElems(...) // => ...
```

### `head`

**Description:** Performs the `head` operation.

```js
head(...) // => ...
```

### `includes`

**Description:** Checks if an item exists in a list.

```js
includes(...) // => ...
```

### `indexOf`

**Description:** Performs the `indexOf` operation.

```js
indexOf(...) // => ...
```

### `intersection`

**Description:** Performs the `intersection` operation.

```js
intersection(...) // => ...
```

### `intersperse`

**Description:** Performs the `intersperse` operation.

```js
intersperse(...) // => ...
```

### `join`

**Description:** Joins elements of an array into a string.

```js
join('-')([1, 2, 3]) // => '1-2-3'
```

### `joinArray`

**Description:** Performs the `joinArray` operation.

```js
joinArray(...) // => ...
```

### `keep`

**Description:** Performs the `keep` operation.

```js
keep(...) // => ...
```

### `keys`

**Description:** Performs the `keys` operation.

```js
keys(...) // => ...
```

### `last`

**Description:** Performs the `last` operation.

```js
last(...) // => ...
```

### `lastIndexOf`

**Description:** Performs the `lastIndexOf` operation.

```js
lastIndexOf(...) // => ...
```

### `map`

**Description:** Applies `map` operation to a list.

```js
map(x => x * 2)([1, 2, 3]) // => [2, 4, 6]
```

### `partition`

**Description:** Performs the `partition` operation.

```js
partition(...) // => ...
```

### `push`

**Description:** Performs the `push` operation.

```js
push(...) // => ...
```

### `reduce`

**Description:** Applies `reduce` operation to a list.

```js
reduce((a, b) => a + b)([1, 2, 3]) // => 6
```

### `reject`

**Description:** Performs the `reject` operation.

```js
reject(...) // => ...
```

### `reverse`

**Description:** Performs the `reverse` operation.

```js
reverse([1, 2, 3]) // => [3, 2, 1]
```

### `second`

**Description:** Performs the `second` operation.

```js
second(...) // => ...
```

### `shallowCopy`

**Description:** Performs the `shallowCopy` operation.

```js
shallowCopy(...) // => ...
```

### `shuffle`

**Description:** Performs the `shuffle` operation.

```js
shuffle(...) // => ...
```

### `slice`

**Description:** Performs the `slice` operation.

```js
slice(...) // => ...
```

### `some`

**Description:** Performs the `some` operation.

```js
some(...) // => ...
```

### `sort`

**Description:** Performs the `sort` operation.

```js
sort(...) // => ...
```

### `spread`

**Description:** Performs the `spread` operation.

```js
spread(...) // => ...
```

### `tail`

**Description:** Performs the `tail` operation.

```js
tail(...) // => ...
```

### `take`

**Description:** Performs the `take` operation.

```js
take(...) // => ...
```

### `toObject`

**Description:** Converts input using `toObject`.

```js
toObject(...) // => ...
```

### `union`

**Description:** Performs the `union` operation.

```js
union(...) // => ...
```

### `uniq`

**Description:** Performs the `uniq` operation.

```js
uniq([1, 2, 2, 3]) // => [1, 2, 3]
```

### `unzip`

**Description:** Performs the `unzip` operation.

```js
unzip(...) // => ...
```



## Helpers

### `flip`

**Description:** Performs the `flip` operation.

```js
flip(...) // => ...
```

### `setCountMap`

**Description:** Performs the `setCountMap` operation.

```js
setCountMap(...) // => ...
```



## Number functions

### `abs`

**Description:** Performs the `abs` operation.

```js
abs(...) // => ...
```

### `add`

**Description:** Returns the result of `add` operation on two numbers.

```js
add(2)(3) // => 5
```

### `ceil`

**Description:** Performs the `ceil` operation.

```js
ceil(...) // => ...
```

### `dec`

**Description:** Performs the `dec` operation.

```js
dec(...) // => ...
```

### `div`

**Description:** Returns the result of `div` operation on two numbers.

```js
div(10)(2) // => 5
```

### `divBy`

**Description:** Performs the `divBy` operation.

```js
divBy(...) // => ...
```

### `floor`

**Description:** Performs the `floor` operation.

```js
floor(...) // => ...
```

### `inc`

**Description:** Performs the `inc` operation.

```js
inc(...) // => ...
```

### `max`

**Description:** Performs the `max` operation.

```js
max(...) // => ...
```

### `min`

**Description:** Performs the `min` operation.

```js
min(...) // => ...
```

### `mod`

**Description:** Returns the result of `mod` operation on two numbers.

```js
mod(10)(3) // => 1
```

### `mul`

**Description:** Returns the result of `mul` operation on two numbers.

```js
mul(3)(4) // => 12
```

### `negate`

**Description:** Performs the `negate` operation.

```js
negate(...) // => ...
```

### `round`

**Description:** Performs the `round` operation.

```js
round(...) // => ...
```

### `sqrt`

**Description:** Performs the `sqrt` operation.

```js
sqrt(...) // => ...
```

### `square`

**Description:** Performs the `square` operation.

```js
square(...) // => ...
```

### `sub`

**Description:** Returns the result of `sub` operation on two numbers.

```js
sub(5)(2) // => 3
```

### `subBy`

**Description:** Performs the `subBy` operation.

```js
subBy(...) // => ...
```

### `sum`

**Description:** Performs the `sum` operation.

```js
sum(...) // => ...
```

### `toFixed`

**Description:** Converts input using `toFixed`.

```js
toFixed(...) // => ...
```

### `toLocaleString`

**Description:** Converts input using `toLocaleString`.

```js
toLocaleString(...) // => ...
```



## Objects

### `getKeys`

**Description:** Performs the `getKeys` operation.

```js
getKeys(...) // => ...
```

### `getProp`

**Description:** Returns the value of a specified property from an object.

```js
getProp(...) // => ...
```

### `getValues`

**Description:** Performs the `getValues` operation.

```js
getValues(...) // => ...
```

### `groupBy`

**Description:** Groups a list of items based on a key or function.

```js
groupBy(x => x % 2)([1, 2, 3, 4]) // => { '0': [2, 4], '1': [1, 3] }
```

### `groupByProp`

**Description:** Performs the `groupByProp` operation.

```js
groupByProp(...) // => ...
```

### `pluck`

**Description:** Returns the value of a specified property from an object.

```js
pluck('id')({ id: 42 }) // => 42
```

### `toArray`

**Description:** Converts input using `toArray`.

```js
toArray(...) // => ...
```



## String functions

### `append`

**Description:** Performs the `append` operation.

```js
append(...) // => ...
```

### `capitalize`

**Description:** Performs the `capitalize` operation.

```js
capitalize('hello') // => 'Hello'
```

### `endsWith`

**Description:** Performs the `endsWith` operation.

```js
endsWith(...) // => ...
```

### `getLength`

**Description:** Performs the `getLength` operation.

```js
getLength(...) // => ...
```

### `length`

**Description:** Performs the `length` operation.

```js
length(...) // => ...
```

### `padEnd`

**Description:** Performs the `padEnd` operation.

```js
padEnd(...) // => ...
```

### `padStart`

**Description:** Performs the `padStart` operation.

```js
padStart(...) // => ...
```

### `parseJSON`

**Description:** Performs the `parseJSON` operation.

```js
parseJSON(...) // => ...
```

### `repeat`

**Description:** Performs the `repeat` operation.

```js
repeat(...) // => ...
```

### `replace`

**Description:** Performs the `replace` operation.

```js
replace(...) // => ...
```

### `replaceAll`

**Description:** Performs the `replaceAll` operation.

```js
replaceAll(...) // => ...
```

### `reverseChars`

**Description:** Performs the `reverseChars` operation.

```js
reverseChars(...) // => ...
```

### `split`

**Description:** Splits a string into an array.

```js
split('-')('1-2-3') // => ['1', '2', '3']
```

### `splitChars`

**Description:** Performs the `splitChars` operation.

```js
splitChars(...) // => ...
```

### `splitOnSpace`

**Description:** Performs the `splitOnSpace` operation.

```js
splitOnSpace(...) // => ...
```

### `startsWith`

**Description:** Performs the `startsWith` operation.

```js
startsWith(...) // => ...
```

### `stringify`

**Description:** Performs the `stringify` operation.

```js
stringify(...) // => ...
```

### `substring`

**Description:** Performs the `substring` operation.

```js
substring(...) // => ...
```

### `toLocaleLowerCase`

**Description:** Converts input using `toLocaleLowerCase`.

```js
toLocaleLowerCase(...) // => ...
```

### `toLocaleUpperCase`

**Description:** Converts input using `toLocaleUpperCase`.

```js
toLocaleUpperCase(...) // => ...
```

### `toLowerCase`

**Description:** Converts input using `toLowerCase`.

```js
toLowerCase(...) // => ...
```

### `toUpperCase`

**Description:** Converts input using `toUpperCase`.

```js
toUpperCase(...) // => ...
```

### `trim`

**Description:** Performs the `trim` operation.

```js
trim('  hello ') // => 'hello'
```

### `truncateWords`

**Description:** Performs the `truncateWords` operation.

```js
truncateWords(...) // => ...
```



## Utils

### `apply`

**Description:** Performs the `apply` operation.

```js
apply(...) // => ...
```

### `applyReducer`

**Description:** Performs the `applyReducer` operation.

```js
applyReducer(...) // => ...
```

### `applyToIndex`

**Description:** Performs the `applyToIndex` operation.

```js
applyToIndex(...) // => ...
```

### `compose`

**Description:** Composes functions right-to-left.

```js
compose(x => x + 1, x => x * 2)(3) // => 7
```

### `composeState`

**Description:** Performs the `composeState` operation.

```js
composeState(...) // => ...
```

### `curry`

**Description:** Transforms a function into its curried version.

```js
const add3 = (a, b, c) => a + b + c;
curry(add3)(1)(2)(3) // => 6
```

### `identity`

**Description:** Returns the input unchanged.

```js
identity(42) // => 42
```

### `mapAll`

**Description:** Performs the `mapAll` operation.

```js
mapAll(...) // => ...
```

### `partial`

**Description:** Partially applies arguments to a function.

```js
partial((a, b) => a + b)(1)(2) // => 3
```

### `pipe`

**Description:** Composes functions left-to-right.

```js
pipe(x => x + 1, x => x * 2)(3) // => 8
```

### `thrush`

**Description:** Performs the `thrush` operation.

```js
thrush(...) // => ...
```

### `uncurry`

**Description:** Transforms a curried function into a variadic function.

```js
uncurry(...) // => ...
```

### `withLogger`

**Description:** Performs the `withLogger` operation.

```js
withLogger(...) // => ...
```

### `withSet`

**Description:** Performs the `withSet` operation.

```js
withSet(...) // => ...
```



## debugging functions

### `collapsed`

**Description:** Performs the `collapsed` operation.

```js
collapsed(...) // => ...
```

### `getType`

**Description:** Performs the `getType` operation.

```js
getType(...) // => ...
```

### `group`

**Description:** Performs the `group` operation.

```js
group(...) // => ...
```

### `groupEnd`

**Description:** Performs the `groupEnd` operation.

```js
groupEnd(...) // => ...
```

### `log`

**Description:** Performs the `log` operation.

```js
log(...) // => ...
```

### `note`

**Description:** Performs the `note` operation.

```js
note(...) // => ...
```

### `panic`

**Description:** Performs the `panic` operation.

```js
panic(...) // => ...
```

### `see`

**Description:** Performs the `see` operation.

```js
see(...) // => ...
```

### `snitch`

**Description:** Performs the `snitch` operation.

```js
snitch(...) // => ...
```

### `table`

**Description:** Performs the `table` operation.

```js
table(...) // => ...
```

### `tap`

**Description:** Applies a function to the input for side effects and returns the input.

```js
tap(console.log)('value') // logs 'value' and returns it
```

### `tee`

**Description:** Performs the `tee` operation.

```js
tee(...) // => ...
```

### `tell`

**Description:** Performs the `tell` operation.

```js
tell(...) // => ...
```



## predicates

### `and`

**Description:** Performs the `and` operation.

```js
and(...) // => ...
```

### `isArray`

**Description:** Returns true if the input satisfies the `isArray` condition.

```js
isArray(...) // => ...
```

### `isClickOrEnter`

**Description:** Returns true if the input satisfies the `isClickOrEnter` condition.

```js
isClickOrEnter(...) // => ...
```

### `isDivBy`

**Description:** Returns true if the input satisfies the `isDivBy` condition.

```js
isDivBy(...) // => ...
```

### `isEmptyArray`

**Description:** Returns true if the input satisfies the `isEmptyArray` condition.

```js
isEmptyArray(...) // => ...
```

### `isEq`

**Description:** Returns true if the input satisfies the `isEq` condition.

```js
isEq(...) // => ...
```

### `isEven`

**Description:** Returns true if the input satisfies the `isEven` condition.

```js
isEven(...) // => ...
```

### `isGt`

**Description:** Returns true if the input satisfies the `isGt` condition.

```js
isGt(...) // => ...
```

### `isGtE`

**Description:** Returns true if the input satisfies the `isGtE` condition.

```js
isGtE(...) // => ...
```

### `isLetter`

**Description:** Returns true if the input satisfies the `isLetter` condition.

```js
isLetter(...) // => ...
```

### `isLetterOrNumber`

**Description:** Returns true if the input satisfies the `isLetterOrNumber` condition.

```js
isLetterOrNumber(...) // => ...
```

### `isLooseEq`

**Description:** Returns true if the input satisfies the `isLooseEq` condition.

```js
isLooseEq(...) // => ...
```

### `isLowerCase`

**Description:** Returns true if the input satisfies the `isLowerCase` condition.

```js
isLowerCase(...) // => ...
```

### `isLt`

**Description:** Returns true if the input satisfies the `isLt` condition.

```js
isLt(...) // => ...
```

### `isLtE`

**Description:** Returns true if the input satisfies the `isLtE` condition.

```js
isLtE(...) // => ...
```

### `isMap`

**Description:** Returns true if the input satisfies the `isMap` condition.

```js
isMap(...) // => ...
```

### `isNaN`

**Description:** Returns true if the input satisfies the `isNaN` condition.

```js
isNaN(...) // => ...
```

### `isNotEmptyArray`

**Description:** Returns true if the input satisfies the `isNotEmptyArray` condition.

```js
isNotEmptyArray(...) // => ...
```

### `isNotEmptyString`

**Description:** Returns true if the input satisfies the `isNotEmptyString` condition.

```js
isNotEmptyString(...) // => ...
```

### `isNullish`

**Description:** Returns true if the input satisfies the `isNullish` condition.

```js
isNullish(...) // => ...
```

### `isNumber`

**Description:** Returns true if the input satisfies the `isNumber` condition.

```js
isNumber(...) // => ...
```

### `isOdd`

**Description:** Returns true if the input satisfies the `isOdd` condition.

```js
isOdd(...) // => ...
```

### `isSame`

**Description:** Returns true if the input satisfies the `isSame` condition.

```js
isSame(...) // => ...
```

### `isSet`

**Description:** Returns true if the input satisfies the `isSet` condition.

```js
isSet(...) // => ...
```

### `isSpace`

**Description:** Returns true if the input satisfies the `isSpace` condition.

```js
isSpace(...) // => ...
```

### `isSpecialChar`

**Description:** Returns true if the input satisfies the `isSpecialChar` condition.

```js
isSpecialChar(...) // => ...
```

### `isUniq`

**Description:** Returns true if the input satisfies the `isUniq` condition.

```js
isUniq(...) // => ...
```

### `isUpperCase`

**Description:** Returns true if the input satisfies the `isUpperCase` condition.

```js
isUpperCase(...) // => ...
```

### `not`

**Description:** Performs the `not` operation.

```js
not(x => x > 1)(2) // => false
```

### `or`

**Description:** Performs the `or` operation.

```js
or(...) // => ...
```


